Index: main/core/src/main/java/hudson/model/ListView.java
===================================================================
--- main/core/src/main/java/hudson/model/ListView.java	(revision 17307)
+++ main/core/src/main/java/hudson/model/ListView.java	(working copy)
@@ -36,6 +36,7 @@
 import hudson.views.WeatherColumn;
 import hudson.model.Descriptor.FormException;
 import hudson.util.CaseInsensitiveComparator;
+import hudson.util.DescribableList;
 import hudson.util.FormValidation;
 
 import org.kohsuke.stapler.StaplerRequest;
@@ -64,6 +65,11 @@
      */
     /*package*/ final SortedSet<String> jobNames = new TreeSet<String>(CaseInsensitiveComparator.INSTANCE);
 
+    /*
+    private final DescribableList<ListViewColumn,Descriptor<ListViewColumn>> displayedColumns =
+            new DescribableList<ListViewColumn,Descriptor<ListViewColumn>>(this);
+     */
+
     protected transient List<ListViewColumn> columns = new ArrayList<ListViewColumn>();
 
     // First add all the known instances in the correct order:
Index: main/core/src/main/java/hudson/views/LastStableColumn.java
===================================================================
--- main/core/src/main/java/hudson/views/LastStableColumn.java	(revision 0)
+++ main/core/src/main/java/hudson/views/LastStableColumn.java	(revision 0)
@@ -0,0 +1,53 @@
+/*
+ * The MIT License
+ * 
+ * Copyright (c) 2004-2009, Sun Microsystems, Inc., Kohsuke Kawaguchi, Martin Eigenbrodt
+ * 
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ * 
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+package hudson.views;
+
+import hudson.Extension;
+import hudson.model.Descriptor;
+import net.sf.json.JSONObject;
+
+import org.kohsuke.stapler.StaplerRequest;
+
+public class LastStableColumn extends ListViewColumn {
+
+    public Descriptor<ListViewColumn> getDescriptor() {
+        return DESCRIPTOR;
+    }
+    
+    public static final Descriptor<ListViewColumn> DESCRIPTOR = new DescriptorImpl();
+
+    @Extension
+    public static class DescriptorImpl extends Descriptor<ListViewColumn> {
+        @Override
+        public ListViewColumn newInstance(StaplerRequest req, JSONObject formData) throws FormException {
+            // This will be called with req == null also the Descriptor's doc tells you not. so the default impl fails
+            return new LastStableColumn();
+        }
+
+        @Override
+        public String getDisplayName() {
+            return "Last Stable";
+        }
+    }
+}

Property changes on: main/core/src/main/java/hudson/views/LastStableColumn.java
___________________________________________________________________
Added: svn:eol-style
   + native

Index: main/core/src/main/resources/hudson/views/LastStableColumn/columnHeader.jelly
===================================================================
--- main/core/src/main/resources/hudson/views/LastStableColumn/columnHeader.jelly	(revision 0)
+++ main/core/src/main/resources/hudson/views/LastStableColumn/columnHeader.jelly	(revision 0)
@@ -0,0 +1,27 @@
+<!--
+The MIT License
+
+Copyright (c) 2004-2009, Sun Microsystems, Inc., Kohsuke Kawaguchi, Martin Eigenbrodt
+
+Permission is hereby granted, free of charge, to any person obtaining a copy
+of this software and associated documentation files (the "Software"), to deal
+in the Software without restriction, including without limitation the rights
+to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+copies of the Software, and to permit persons to whom the Software is
+furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in
+all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+THE SOFTWARE.
+-->
+
+<j:jelly xmlns:j="jelly:core">
+    <th>${%Last Stable}</th>
+</j:jelly>
\ No newline at end of file
Index: main/core/src/main/resources/hudson/views/LastStableColumn/column.jelly
===================================================================
--- main/core/src/main/resources/hudson/views/LastStableColumn/column.jelly	(revision 0)
+++ main/core/src/main/resources/hudson/views/LastStableColumn/column.jelly	(revision 0)
@@ -0,0 +1,38 @@
+<!--
+The MIT License
+
+Copyright (c) 2004-2009, Sun Microsystems, Inc., Kohsuke Kawaguchi, Martin Eigenbrodt
+
+Permission is hereby granted, free of charge, to any person obtaining a copy
+of this software and associated documentation files (the "Software"), to deal
+in the Software without restriction, including without limitation the rights
+to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+copies of the Software, and to permit persons to whom the Software is
+furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in
+all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+THE SOFTWARE.
+-->
+
+<j:jelly xmlns:j="jelly:core" xmlns:st="jelly:stapler" xmlns:d="jelly:define" xmlns:l="/lib/layout" xmlns:t="/lib/hudson" xmlns:f="/lib/form" xmlns:i="jelly:fmt">
+    <j:set var="lstBuild" value="${job.lastStableBuild}"/>
+    <td data="${lstBuild.timestampString2 ?: '-'}">
+          <j:choose>
+              <j:when test="${lstBuild!=null}">
+                  ${lstBuild.timestampString}
+                  (<a href="${jobBaseUrl}${job.shortUrl}lastStableBuild/">#${lstBuild.number}</a>)
+              </j:when>
+              <j:otherwise>
+                  ${%N/A}
+              </j:otherwise>
+          </j:choose>
+      </td>
+</j:jelly>
\ No newline at end of file